"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.boot = exports.register = exports.api = exports.name = void 0;
require("./interface");
const bud_build_1 = require("@roots/bud-build");
const fs_extra_1 = require("fs-extra");
const Config_1 = require("./Config");
exports.name = '@roots/bud-babel';
const api = (app) => ({
    babel: new Config_1.Config().init(app),
});
exports.api = api;
const register = app => {
    app.build.loaders.babel = new bud_build_1.Loader(require.resolve('babel-loader'));
    app.build.items.babel = new bud_build_1.Item({
        loader: ({ build }) => build.loaders.babel,
        options: app => {
            var _a, _b;
            const options = {
                cacheDirectory: app.path('storage', 'cache/babel'),
                root: app.path('src'),
            };
            if ((_a = app.babel) === null || _a === void 0 ? void 0 : _a.presets) {
                options.presets = Object.values(app.babel.presets);
            }
            if ((_b = app.babel) === null || _b === void 0 ? void 0 : _b.plugins) {
                options.plugins = Object.values(app.babel.plugins);
            }
            return options;
        },
    });
    app.build.rules.js.setUse(({ build }) => [build.items.babel]);
};
exports.register = register;
const boot = app => {
    !fs_extra_1.existsSync(app.path('project', 'babel.config.js')) &&
        app.babel
            .setPresets(['@babel/preset-env'])
            .setPlugins([
            ['@babel/plugin-transform-runtime', { helpers: false }],
            '@babel/plugin-proposal-object-rest-spread',
            '@babel/plugin-syntax-dynamic-import',
            '@babel/plugin-proposal-class-properties',
        ]);
};
exports.boot = boot;
//# sourceMappingURL=extension.js.map